﻿
Public Class Form1


    Friend VideoMode As VideoModes = VideoModes.Normal
    Friend NormalLocation As Point
    Friend LargeLocation As Point
    Friend NormalSize As Size
    Friend LargeSize As Size
    Private Slot_Input1 As Int32
    Private Slot_Change1 As Int32
    Private Slot_Red1 As Int32
    Private Slot_Green1 As Int32
    Private Slot_Blue1 As Int32
    Private Slot_Input2 As Int32
    Private Slot_Change2 As Int32
    Private Slot_Red2 As Int32
    Private Slot_Green2 As Int32
    Private Slot_Blue2 As Int32
    Friend VideoFile1_Index As Int32
    Friend VideoFile2_Index As Int32

    Private EventsAreEnabled As Boolean = False
    Private ScreenAspectRatio As Single

    Friend Enum VideoModes As Int32
        Normal = 1
        Large = 2
        FullScreen = 3
    End Enum

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim s As String
        s = IO.Path.GetFileNameWithoutExtension(Application.StartupPath)
        If s.ToLower = "bin" Then
            s = IO.Path.GetFileNameWithoutExtension(IO.Directory.GetParent(Application.StartupPath).ToString)
        End If
        Text = appTitleAndVersion("Theremino Video Player")
        Me.Text &= "  ( " & s & " )"
        ScreenAspectRatio = CSng(Screen.PrimaryScreen.Bounds.Width / Screen.PrimaryScreen.Bounds.Height)
        ToolTips_Init()
        MemoryMappedFile_Init()
        Load_INI()
        If My.Computer.Screen.BitsPerPixel <> 32 Then chk_Enable2.Checked = False
        EnableChannelControls1()
        EnableChannelControls2()
        AV1 = New AviStream_API
        AV2 = New AviStream_API
        DX = New VideoDX()
        InitDxDevice()
        SetVideoMode(VideoMode)
        StartThereminoHAL()

        Timer100Hz.Interval = 10
        Timer100Hz.Start()
        Timer5Hz.Interval = 200
        Timer5Hz.Start()

        EventsAreEnabled = True
        Set_Props()
        Refresh()
        If Slot_Change1 < 0 Then OpenVideoFile1(VideoFile1_Index)
        If Slot_Change2 < 0 Then OpenVideoFile2(VideoFile2_Index)
        EventsAreEnabled = True
    End Sub

    Private Sub Form_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        ShowCursor()
        ShowTrayWnd()
        AV1.CloseAll()
        AV2.CloseAll()
        DX.CloseAll()
        Save_INI()
    End Sub


    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================

    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 500
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(txt_SlotIn1, _
                        "Video Position ( input )" & vbCr & _
                        "-------------------------------------" & vbCr & _
                        "The video position is controlled" & vbCr & _
                        "by this slot with a float value " & vbCr & _
                        "from 0.0 to 1000.0.")

        ttp1.SetToolTip(txt_SlotChange1, _
                        "Video File Change ( input )" & vbCr & _
                        "-------------------------------------" & vbCr & _
                        "The current video file is changed" & vbCr & _
                        "by a file index on this slot.")

        ttp1.SetToolTip(txt_SlotIn2, _
                        "Video Position ( input )" & vbCr & _
                        "-------------------------------------" & vbCr & _
                        "The video position is controlled" & vbCr & _
                        "by this slot with a float value " & vbCr & _
                        "from 0.0 to 1000.0.")

        ttp1.SetToolTip(txt_SlotChange2, _
                        "Video File Change ( input )" & vbCr & _
                        "-------------------------------------" & vbCr & _
                        "The current video file is changed" & vbCr & _
                        "by a file index on this slot.")

    End Sub

    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub Tooltips_MouseEnter(ByVal sender As Object, _
                                    ByVal e As System.EventArgs) Handles txt_SlotIn1.MouseEnter, _
                                                                         txt_SlotChange1.MouseEnter, _
                                                                         txt_SlotIn2.MouseEnter, _
                                                                         txt_SlotChange2.MouseEnter, _
                                                                         tk_Position1.MouseEnter, _
                                                                         tk_Position2.MouseEnter, _
                                                                         chk_Enable2.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub




    ' ==============================================================================================================
    '  CURSOR TIMED HIDE  -  4 to 15 uS
    ' ==============================================================================================================
    Private HideTimer As Stopwatch = New Stopwatch
    Private HideCursor_OldPos As Point = New Point(-99999, -99999)
    Private Sub Cursor_TimedHide()
        'Dim sw1 As Stopwatch = New Stopwatch
        'sw1.Reset()
        'sw1.Start()
        If VideoMode = VideoModes.Normal Then
            ShowCursor()
        Else
            If HideTimer.ElapsedMilliseconds < 3000 Then
                ShowCursor()
            Else
                HideCursor()
            End If
        End If
        If Cursor.Position <> HideCursor_OldPos Then
            HideCursor_OldPos = Cursor.Position
            ShowCursor()
            HideTimer.Reset()
            HideTimer.Start()
        End If
        'Text = (sw1.Elapsed.TotalMilliseconds * 1000).ToString("0")
    End Sub


    ' ==============================================================================================================
    '   HIDE SHOW CURSOR  ( BlankCursor for MONO - LINUX )
    ' ==============================================================================================================
    Private BlankCursor As Cursor = New Cursor(New IO.MemoryStream(My.Resources.BlankCursor))
    Private CursorVisible As Boolean = True
    Friend Sub HideCursor()
        If CursorVisible Then
            CursorVisible = False
            Cursor.Hide()
            Cursor = BlankCursor
        End If
    End Sub
    Friend Sub ShowCursor()
        If Not CursorVisible Then
            CursorVisible = True
            Cursor.Show()
            Cursor = Cursors.Default
        End If
    End Sub



    ' ==========================================================================================================
    '  START THEREMINO HAL
    ' ==========================================================================================================

    Private Sub StartThereminoHAL()
        ' ----------------------------------------------------------- test if process "Theremino_HAL" is running
        For Each proc As Process In Process.GetProcesses
            If proc.ProcessName = "Theremino_HAL" Then Exit Sub
        Next
        ' ----------------------------------------------------------- try to start it from the "ApplicationPath"
        Dim psi As New ProcessStartInfo
        psi.WorkingDirectory = Application.StartupPath
        psi.FileName = psi.WorkingDirectory & "\Theremino_HAL.exe"
        If FileExists(psi.FileName) Then Process.Start(psi)
        ' ----------------------------------------------------------- test if process "Theremino_HAL" is running
        For Each proc As Process In Process.GetProcesses
            If proc.ProcessName = "Theremino_HAL" Then Exit Sub
        Next
        ' ----------------------------------------------------------- try to start it from "Programs"
        psi.WorkingDirectory = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) & "\Theremino"
        psi.FileName = psi.WorkingDirectory & "\Theremino_HAL.exe"
        If FileExists(psi.FileName) Then Process.Start(psi)
    End Sub


    ' ===================================================================================================
    '  ContextMenuStrip
    ' ===================================================================================================
    Private Sub Panel1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel1.MouseUp
        If e.Button = Windows.Forms.MouseButtons.Right Then
            ContextMenuStrip1.Show(Panel1, e.Location)
        End If
        LimitFormPosition(Me)
        StopFormMove()
        Save_INI()
    End Sub
    Private Sub CloseProgramToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseProgramToolStripMenuItem.Click
        Me.Close()
    End Sub


    ' ===================================================================================================
    '  Form Move and Resize
    ' ===================================================================================================
    Private CorrectAspectRatio As Boolean = False

    Private Sub Panel1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Panel1.Paint
        ShowVideo()
    End Sub

    Private Sub Form1_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SizeChanged
        If Not EventsAreEnabled Then Return
        If WindowState = FormWindowState.Minimized Then Return
        If VideoMode = VideoModes.FullScreen Then Return
        Save_INI()
        InitDxDevice()
        ShowVideo()
    End Sub

    'Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
    '    'If Not EventsAreEnabled Then Return
    '    'ShowVideo()
    'End Sub

    Private Sub Form1_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        If Not EventsAreEnabled Then Return
        CorrectFormSize()
        Save_INI()
        InitDxDevice()
        ShowVideo()
    End Sub

    Private Sub Form1_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        If Not EventsAreEnabled Then Return
        HideOrShowTrayWnd()
    End Sub

    Private Sub Panel1_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel1.MouseWheel
        If WindowState <> FormWindowState.Normal Then Return
        If VideoMode = VideoModes.FullScreen Then Return
        If Not Me.ClientRectangle.Contains(e.Location) Then Return
        Timer100Hz.Stop()
        EventsAreEnabled = False
        Dim n As Int32 = e.Delta \ 4
        If My.Computer.Keyboard.CtrlKeyDown Then
            CorrectAspectRatio = False
            Me.Size = Size.Add(Me.Size, New Size(n, 0))
        ElseIf My.Computer.Keyboard.ShiftKeyDown Then
            CorrectAspectRatio = False
            Me.Size = Size.Add(Me.Size, New Size(0, n))
        Else
            CorrectAspectRatio = True
            Me.Size = Size.Add(Me.Size, New Size(0, n))
        End If
        CorrectFormSize()
        EventsAreEnabled = True
        Timer100Hz.Start()
        HideOrShowTrayWnd()
        Save_INI()
        InitDxDevice()
        ShowVideo()
    End Sub

    Private Sub CorrectFormSize()
        LimitFormPosition(Me)
        Select Case VideoMode
            Case VideoModes.Normal
                If CorrectAspectRatio Then
                    If Math.Abs(Width - NormalSize.Width) <= Math.Abs(Height - NormalSize.Height) Then
                        Width = CInt((Height - 100) * ScreenAspectRatio)
                    Else
                        Height = 110 + CInt(Width / ScreenAspectRatio)
                    End If
                End If
                NormalLocation = Me.Location
                NormalSize = Me.Size
            Case VideoModes.Large
                If CorrectAspectRatio Then
                    If Math.Abs(Width - LargeSize.Width) <= Math.Abs(Height - LargeSize.Height) Then
                        Width = CInt(Height * ScreenAspectRatio)
                    Else
                        Height = CInt(Width / ScreenAspectRatio)
                    End If
                End If
                LargeLocation = Me.Location
                LargeSize = Me.Size
        End Select
    End Sub



    ' ==========================================================================================================
    '  MOVE BY MOUSE
    ' ==========================================================================================================
    Private CursorStartPos As Point
    Private FormStartPos As Point = New Point(-9999, 0)
    Private Sub StartFormMove()
        CursorStartPos = Cursor.Position
        FormStartPos = Me.Location
    End Sub
    Private Sub StopFormMove()
        FormStartPos.X = -9999
        Select Case VideoMode
            Case VideoModes.Normal
                NormalLocation = Me.Location
            Case VideoModes.Large
                LargeLocation = Me.Location
        End Select
    End Sub
    Private Sub ContinueFormMove(ByVal e As System.Windows.Forms.MouseEventArgs)
        If FormStartPos.X < -9000 Then Return
        If WindowState <> FormWindowState.Normal Then Return
        If VideoMode = VideoModes.FullScreen Then Return
        If e.Button = Windows.Forms.MouseButtons.Left Then
            Me.Location = New Point(FormStartPos.X + Cursor.Position.X - CursorStartPos.X, _
                                    FormStartPos.Y + Cursor.Position.Y - CursorStartPos.Y)
        End If
    End Sub

    Private Sub Panel1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel1.MouseMove
        ContinueFormMove(e)
        Panel1.Focus()
    End Sub



    ' ==========================================================================================================
    '  VideoModes - NORMAL / LARGE / FULL SCREEN
    ' ==========================================================================================================

    Private Sub Panel1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel1.MouseDown
        If e.Button = MouseButtons.Left And e.Clicks = 2 Then
            If WindowState = FormWindowState.Maximized And FormBorderStyle <> FormBorderStyle.None Then
                SetVideoMode(VideoModes.Normal)
            Else
                Select Case VideoMode
                    Case VideoModes.Normal : SetVideoMode(VideoModes.Large)
                    Case VideoModes.Large : SetVideoMode(VideoModes.FullScreen)
                    Case VideoModes.FullScreen : SetVideoMode(VideoModes.Normal)
                    Case Else : SetVideoMode(VideoModes.Normal)
                End Select
            End If
            Save_INI()
            InitDxDevice()
        Else
            StartFormMove()
        End If
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        If e.KeyCode = Keys.Escape Then
            SetVideoMode(VideoModes.Normal)
        End If
    End Sub

    Private Sub SetVideoMode(ByVal vmode As VideoModes)
        '
        EventsAreEnabled = False
        '
        If vmode <> VideoMode Then
            Select Case VideoMode
                Case VideoModes.Normal
                    If WindowState = FormWindowState.Normal Then
                        NormalLocation = Me.Location
                        NormalSize = Me.Size
                    End If
                Case VideoModes.Large
                    LargeLocation = Me.Location
                    LargeSize = Me.Size
            End Select
        End If
        '
        Me.Visible = False
        '
        WindowState = FormWindowState.Normal
        VideoMode = vmode
        '
        If VideoMode = VideoModes.Normal Then
            GroupBox1.Visible = True
            GroupBox2.Visible = True
            GroupBox3.Visible = True
        Else
            GroupBox1.Visible = False
            GroupBox2.Visible = False
            GroupBox3.Visible = False
        End If
        '
        Select Case VideoMode
            Case VideoModes.Normal
                ShowTrayWnd()
                Me.MinimumSize = New Size(448, 300)
                FormBorderStyle = FormBorderStyle.Sizable
                Me.Location = NormalLocation
                Me.Size = NormalSize
                Panel1.Location = New Point(4, 4)
                Panel1.Size = Size.Subtract(Me.Size, New Size(16, 112))
                LimitFormPosition(Me)
            Case VideoModes.Large
                Me.MinimumSize = New Size(64, 64)
                FormBorderStyle = FormBorderStyle.None
                Me.Location = LargeLocation
                Me.Size = LargeSize
                HideOrShowTrayWnd()
                Panel1.Location = New Point(0, 0)
                Panel1.Size = Me.Size
                LimitFormPosition(Me)
            Case VideoModes.FullScreen
                Me.MinimumSize = New Size(64, 64)
                FormBorderStyle = FormBorderStyle.None
                Dim r As Rectangle = Screen.GetBounds(Me.Location)
                Me.Location = r.Location
                Me.Size = r.Size
                HideOrShowTrayWnd()
                Panel1.Location = New Point(0, 0)
                Panel1.Size = Me.Size
        End Select

        EventsAreEnabled = True
        Me.Visible = True
    End Sub

    Private Sub HideOrShowTrayWnd()
        If VideoMode <> VideoModes.Large And VideoMode <> VideoModes.FullScreen Then Return
        If Me.Bottom > Screen.PrimaryScreen.WorkingArea.Height - 2 And _
           Me.Left < Screen.PrimaryScreen.WorkingArea.Width Then
            HideTrayWnd()
        Else
            ShowTrayWnd()
        End If
    End Sub



    ' ================================================================================================
    '    TIMERS
    ' ================================================================================================

    Private Sub Timer100Hz_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer100Hz.Tick
        '
        Dim Flag_ShowVideo As Boolean = False
        Dim c As Int32
        '
        If chk_Enable1.Checked Then
            '
            If Slot_Input1 >= 0 Then
                Dim n As Single = ReadSlot_NoNan(Slot_Input1)
                n = n / 1000.0F
                If n > 1 Then n = 1
                If n < 0 Then n = 0
                tk_Position1.Value = CInt(n * 1000)
            End If
            '
            If Slot_Change1 >= 0 Then
                Dim n As Int32 = CInt(ReadSlot_NoNan(Slot_Change1))
                Static oldindex1 As Int32 = -1
                If n <> oldindex1 Then
                    oldindex1 = n
                    OpenVideoFile1(n)
                    Me.TopMost = True
                    Me.TopMost = False
                End If
            End If
            '
            If Slot_Red1 >= 0 Then
                Dim n As Int32 = CInt(ReadSlot_NoNan(Slot_Red1))
                c = CInt(255 * (n / 1000.0F))
            Else
                c = 127
            End If
            If c <> DX.Red1 Then DX.Red1 = c : Flag_ShowVideo = True
            If Slot_Green1 >= 0 Then
                Dim n As Int32 = CInt(ReadSlot_NoNan(Slot_Green1))
                c = CInt(255 * (n / 1000.0F))
            Else
                c = 127
            End If
            If c <> DX.Green1 Then DX.Green1 = c : Flag_ShowVideo = True
            If Slot_Blue1 >= 0 Then
                Dim n As Int32 = CInt(ReadSlot_NoNan(Slot_Blue1))
                c = CInt(255 * (n / 1000.0F))
            Else
                c = 127
            End If
            If c <> DX.Blue1 Then DX.Blue1 = c : Flag_ShowVideo = True
            '
            If AV1.SetVideoPosition(tk_Position1.Value / 1000.0F) Then
                Flag_ShowVideo = True
            End If
        End If
        '
        If chk_Enable2.Checked Then
            '
            If Slot_Input2 >= 0 Then
                Dim n As Single = ReadSlot_NoNan(Slot_Input2)
                n = n / 1000.0F
                If n > 1 Then n = 1
                If n < 0 Then n = 0
                tk_Position2.Value = CInt(n * 1000)
            End If
            '
            If Slot_Change2 >= 0 Then
                Dim n As Int32 = CInt(ReadSlot_NoNan(Slot_Change2))
                Static oldindex2 As Int32 = -1
                If n <> oldindex2 Then
                    oldindex2 = n
                    OpenVideoFile2(n)
                    Me.TopMost = True
                    Me.TopMost = False
                End If
            End If
            '
            If Slot_Red2 >= 0 Then
                Dim n As Int32 = CInt(ReadSlot_NoNan(Slot_Red2))
                c = CInt(255 * (n / 1000.0F))
            Else
                c = 127
            End If
            If c <> DX.Red2 Then DX.Red2 = c : Flag_ShowVideo = True
            If Slot_Green2 >= 0 Then
                Dim n As Int32 = CInt(ReadSlot_NoNan(Slot_Green2))
                c = CInt(255 * (n / 1000.0F))
            Else
                c = 127
            End If
            If c <> DX.Green2 Then DX.Green2 = c : Flag_ShowVideo = True
            If Slot_Blue2 >= 0 Then
                Dim n As Int32 = CInt(ReadSlot_NoNan(Slot_Blue2))
                c = CInt(255 * (n / 1000.0F))
            Else
                c = 127
            End If
            If c <> DX.Blue2 Then DX.Blue2 = c : Flag_ShowVideo = True
            '
            If AV2.SetVideoPosition(tk_Position2.Value / 1000.0F) Then
                Flag_ShowVideo = True
            End If
        End If
        '
        If Flag_ShowVideo Then
            Me.TopMost = True
            Me.TopMost = False
            ShowVideo()
        End If
    End Sub

    Private Sub Timer5Hz_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer5Hz.Tick
        Cursor_TimedHide()
    End Sub




    ' ================================================================================================
    '   SAVE INI ON LOST-FOCUS
    ' ================================================================================================

    Private Sub Properties_LostFocus(ByVal sender As Object, _
                                     ByVal e As System.EventArgs) Handles txt_SlotIn1.LostFocus, _
                                                                          txt_SlotChange1.LostFocus, _
                                                                          txt_SlotRed1.LostFocus, _
                                                                          txt_SlotGreen1.LostFocus, _
                                                                          txt_SlotBlue1.LostFocus, _
                                                                          txt_SlotIn2.LostFocus, _
                                                                          txt_SlotChange2.LostFocus, _
                                                                          txt_SlotRed2.LostFocus, _
                                                                          txt_SlotGreen2.LostFocus, _
                                                                          txt_SlotBlue2.LostFocus, _
                                                                          tk_Position1.LostFocus, _
                                                                          tk_Position2.LostFocus
        Save_INI()
    End Sub



    ' ================================================================================================
    '   SET PROPERTIES
    ' ================================================================================================

    Private Sub txt_SlotIn1_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotIn1.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
        tk_Position1.Value = 0
    End Sub

    Private Sub txt_SlotIn2_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotIn2.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
        tk_Position2.Value = 0
    End Sub

    Private Sub txt_SlotChange1_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotChange1.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub

    Private Sub txt_SlotChange2_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotChange2.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub

    Private Sub txt_SlotColors_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotRed1.TextChanged, _
                                                                                                        txt_SlotGreen1.TextChanged, _
                                                                                                        txt_SlotBlue1.TextChanged, _
                                                                                                        txt_SlotRed2.TextChanged, _
                                                                                                        txt_SlotGreen2.TextChanged, _
                                                                                                        txt_SlotBlue2.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub

    Private Sub Set_Props()
        Slot_Input1 = txt_SlotIn1.NumericValueInteger
        Slot_Change1 = txt_SlotChange1.NumericValueInteger
        Slot_Red1 = txt_SlotRed1.NumericValueInteger
        Slot_Green1 = txt_SlotGreen1.NumericValueInteger
        Slot_Blue1 = txt_SlotBlue1.NumericValueInteger
        Slot_Input2 = txt_SlotIn2.NumericValueInteger
        Slot_Change2 = txt_SlotChange2.NumericValueInteger
        Slot_Red2 = txt_SlotRed2.NumericValueInteger
        Slot_Green2 = txt_SlotGreen2.NumericValueInteger
        Slot_Blue2 = txt_SlotBlue2.NumericValueInteger
        Save_INI()
    End Sub


    ' ==============================================================================================================
    '  EnableChannels
    ' ==============================================================================================================

    Private Sub chk_Enable1_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles chk_Enable1.ClickButtonArea
        If Not EventsAreEnabled Then Return
        EnableChannelControls1()
        DX.ClearDevice()
        ShowVideo()
        Save_INI()
    End Sub

    Private Sub chk_Enable2_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles chk_Enable2.ClickButtonArea
        If Not EventsAreEnabled Then Return
        '
        If chk_Enable2.Checked And My.Computer.Screen.BitsPerPixel <> 32 Then
            chk_Enable2.Checked = False
            MsgBox("Now the screen colors are set to 16 bits." & vbCr & _
                   "With 16 bits the alpha channel is not supported." & vbCr & vbCr & _
                   "Please change the screen properties to 32 bits colors.", MsgBoxStyle.Information)
        End If
        '
        EnableChannelControls2()
        DX.ClearDevice()
        ShowVideo()
        Save_INI()
    End Sub

    Private Sub EnableChannelControls1()
        If chk_Enable1.Checked Then
            txt_SlotIn1.Enabled = True
            txt_SlotIn1.ForeColor = Color.Black
            txt_SlotChange1.Enabled = True
            txt_SlotChange1.ForeColor = Color.Black
            txt_SlotRed1.Enabled = True
            txt_SlotRed1.ForeColor = Color.Black
            txt_SlotGreen1.Enabled = True
            txt_SlotGreen1.ForeColor = Color.Black
            txt_SlotBlue1.Enabled = True
            txt_SlotBlue1.ForeColor = Color.Black
            tk_Position1.Enabled = True
            cmb_VideoFiles1.Enabled = True
            cmb_VideoFiles1.BackColor = Color.MintCream
            cmb_VideoFiles1.ForeColor = Color.Black
        Else
            txt_SlotIn1.Enabled = False
            txt_SlotIn1.ForeColor = Color.Gray
            txt_SlotChange1.Enabled = False
            txt_SlotChange1.ForeColor = Color.Gray
            txt_SlotRed1.Enabled = False
            txt_SlotRed1.ForeColor = Color.Gray
            txt_SlotGreen1.Enabled = False
            txt_SlotGreen1.ForeColor = Color.Gray
            txt_SlotBlue1.Enabled = False
            txt_SlotBlue1.ForeColor = Color.Gray
            tk_Position1.Enabled = False
            cmb_VideoFiles1.Enabled = False
            cmb_VideoFiles1.BackColor = Color.LightGray
            cmb_VideoFiles1.ForeColor = Color.Gray
        End If
    End Sub

    Private Sub EnableChannelControls2()
        If chk_Enable2.Checked Then
            txt_SlotIn2.Enabled = True
            txt_SlotIn2.ForeColor = Color.Black
            txt_SlotChange2.Enabled = True
            txt_SlotChange2.ForeColor = Color.Black
            txt_SlotRed2.Enabled = True
            txt_SlotRed2.ForeColor = Color.Black
            txt_SlotGreen2.Enabled = True
            txt_SlotGreen2.ForeColor = Color.Black
            txt_SlotBlue2.Enabled = True
            txt_SlotBlue2.ForeColor = Color.Black
            tk_Position2.Enabled = True
            cmb_VideoFiles2.Enabled = True
            cmb_VideoFiles2.BackColor = Color.MintCream
            cmb_VideoFiles2.ForeColor = Color.Black
        Else
            txt_SlotIn2.Enabled = False
            txt_SlotIn2.ForeColor = Color.Gray
            txt_SlotChange2.Enabled = False
            txt_SlotChange2.ForeColor = Color.Gray
            txt_SlotRed2.Enabled = False
            txt_SlotRed2.ForeColor = Color.Gray
            txt_SlotGreen2.Enabled = False
            txt_SlotGreen2.ForeColor = Color.Gray
            txt_SlotBlue2.Enabled = False
            txt_SlotBlue2.ForeColor = Color.Gray
            tk_Position2.Enabled = False
            cmb_VideoFiles2.Enabled = False
            cmb_VideoFiles2.BackColor = Color.LightGray
            cmb_VideoFiles2.ForeColor = Color.Gray
        End If
    End Sub


    ' =======================================================================================
    '   COMBO VIDEO FILES
    ' =======================================================================================
    Private Sub cmb_WaveFiles1_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_VideoFiles1.DropDown
        ReadVideoFileNames1()
        If VideoFileNames1 Is Nothing Then Return
        cmb_VideoFiles1.Items.Clear()
        For Each f As String In VideoFileNames1
            cmb_VideoFiles1.Items.Add(My.Computer.FileSystem.GetName(f))
        Next
        cmb_VideoFiles1.SelectedIndex = VideoFile1_Index
    End Sub
    Private Sub cmb_VideoFiles1_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_VideoFiles1.SelectionChangeCommitted
        OpenVideoFile1(cmb_VideoFiles1.SelectedIndex)
        Save_INI()
    End Sub

    Private Sub cmb_WaveFiles2_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_VideoFiles2.DropDown
        ReadVideoFileNames2()
        If VideoFileNames2 Is Nothing Then Return
        cmb_VideoFiles2.Items.Clear()
        For Each f As String In VideoFileNames2
            cmb_VideoFiles2.Items.Add(My.Computer.FileSystem.GetName(f))
        Next
        cmb_VideoFiles2.SelectedIndex = VideoFile2_Index
    End Sub
    Private Sub cmb_VideoFiles2_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_VideoFiles2.SelectionChangeCommitted
        OpenVideoFile2(cmb_VideoFiles2.SelectedIndex)
        Save_INI()
    End Sub



    ' ==========================================================================================================
    '  OPEN VIDEO FILE
    ' ==========================================================================================================
    Private Sub OpenVideoFile1(ByVal numFile As Int32)
        Timer100Hz.Stop()
        ReadVideoFileNames1()
        If VideoFileNames1 Is Nothing Then Timer100Hz.Start() : Return
        If VideoFileNames1.Count < 1 Then Timer100Hz.Start() : Return
        If VideoFile1_Index < 0 Then VideoFile1_Index = 0
        VideoFile1_Index = numFile Mod VideoFileNames1.Count
        Dim s As String = VideoFileNames1(VideoFile1_Index)
        Combo_Init(cmb_VideoFiles1, My.Computer.FileSystem.GetName(s))
        Timer100Hz.Start()
        AV1.LoadVideoFile(s)
    End Sub

    Private Sub OpenVideoFile2(ByVal numFile As Int32)
        Timer100Hz.Stop()
        ReadVideoFileNames2()
        If VideoFileNames2 Is Nothing Then Timer100Hz.Start() : Return
        If VideoFileNames2.Count < 1 Then Timer100Hz.Start() : Return
        If VideoFile2_Index < 0 Then VideoFile2_Index = 0
        VideoFile2_Index = numFile Mod VideoFileNames2.Count
        Dim s As String = VideoFileNames2(VideoFile2_Index)
        Combo_Init(cmb_VideoFiles2, My.Computer.FileSystem.GetName(s))
        Timer100Hz.Start()
        AV2.LoadVideoFile(s)
    End Sub

    Private Sub ShowVideo()
        If chk_Enable1.Checked Then
            AV1.ShowVideoFrame_WithDirect3D(Panel1)
        Else
            AV1.m_Texture = Nothing
        End If
        If chk_Enable2.Checked Then
            AV2.ShowVideoFrame_WithDirect3D(Panel1)
        Else
            AV2.m_Texture = Nothing
        End If
        DX.RenderScene()
    End Sub

    Private Sub InitDxDevice()
        DX.InitGraphics(Panel1)
    End Sub

End Class